? print.patch
Index: src/data/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/ChangeLog,v
retrieving revision 1.66
diff -u -p -r1.66 ChangeLog
--- src/data/ChangeLog	19 Oct 2006 15:04:52 -0000	1.66
+++ src/data/ChangeLog	28 Oct 2006 19:18:51 -0000
@@ -1,3 +1,7 @@
+Sat Oct 28 11:56:50 2006  Ben Pfaff  <blp@gnu.org>
+
+	* format.c (fmt_is_binary): New function.
+
 Thu Oct 19 22:59:56 WST 2006 John Darrington <john@darrington.wattle.id.au>
 
 	* procedure.c procedure.h: Encapsulated the static data into a single
Index: src/data/format.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/format.c,v
retrieving revision 1.9
diff -u -p -r1.9 format.c
--- src/data/format.c	20 Oct 2006 11:32:57 -0000	1.9
+++ src/data/format.c	28 Oct 2006 19:18:51 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -388,6 +388,24 @@ make_output_format (int type, int w, int
   return f;
 }
 
+/* Returns true if TYPE is a binary format,
+   false otherwise. */
+bool
+fmt_is_binary (int type)
+{
+  switch (type) 
+    {
+    case FMT_P:
+    case FMT_PK:
+    case FMT_IB:
+    case FMT_PIB:
+    case FMT_RB:
+      return true;
+
+    default:
+      return false;
+    }
+}
 
 bool 
 measure_is_valid(enum measure m)
Index: src/data/format.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/format.h,v
retrieving revision 1.5
diff -u -p -r1.5 format.h
--- src/data/format.h	20 Oct 2006 11:32:57 -0000	1.5
+++ src/data/format.h	28 Oct 2006 19:18:51 -0000
@@ -124,5 +124,6 @@ char *fmt_to_string (const struct fmt_sp
 void num_to_string (double v, char *s, int w, int d);
 struct fmt_spec make_input_format (int type, int w, int d);
 struct fmt_spec make_output_format (int type, int w, int d);
+bool fmt_is_binary (int type);
 
 #endif /* !format_h */
Index: src/language/data-io/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/ChangeLog,v
retrieving revision 1.28
diff -u -p -r1.28 ChangeLog
--- src/language/data-io/ChangeLog	28 Oct 2006 08:31:23 -0000	1.28
+++ src/language/data-io/ChangeLog	28 Oct 2006 19:18:51 -0000
@@ -1,3 +1,27 @@
+Sat Oct 28 11:57:19 2006  Ben Pfaff  <blp@gnu.org>
+
+	* data-writer.c (struct dfm_writer): Removed `bounce' member, and
+	all references to it.
+	(dfm_put_record) Change semantics so that it adds formatting
+	itself, such as new-line characters, instead of putting that
+	responsibility on the caller.  Also, pad binary records with
+	spaces instead of zeros, for compatibility.
+
+	* print.c (struct prt_out_spec) New member `sysmis_as_spaces'.
+	(struct print_trns) Remove `omit_new_lines' and all references,
+	since dfm_put_record() is taking care of that.  Add
+	`include_prefix'.
+	(internal_cmd_print) Allow an empty set of data to print.  Set
+	include_prefix.
+	(parse_specs) Allow an empty set of data to print.
+	(parse_variable_argument) Only add space with PRINT command.  Set
+	sysmis_as_spaces.
+	(print_trns_proc) Indent records if include_prefix is set, for
+	compatibility.  Output SYSMIS as spaces if sysmis_as_spaces is
+	set.  Put "1" in first column if PRINT EJECT is used with an
+	external output file.
+	(flush_records) Ditto.
+
 Sat Oct 28 16:19:57 WST 2006 John Darrington <john@darrington.wattle.id.au>
 
 	* data-reader.c: Eliminated references to extern variable getl_buf
Index: src/language/data-io/data-writer.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/data-writer.c,v
retrieving revision 1.6
diff -u -p -r1.6 data-writer.c
--- src/language/data-io/data-writer.c	14 Oct 2006 00:25:20 -0000	1.6
+++ src/language/data-io/data-writer.c	28 Oct 2006 19:18:52 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-2004 Free Software Foundation, Inc.
+   Copyright (C) 1997-2004, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -18,16 +18,22 @@
    02110-1301, USA. */
 
 #include <config.h>
+
 #include <language/data-io/data-writer.h>
+
 #include <assert.h>
 #include <errno.h>
 #include <stdlib.h>
+
+#include <data/file-name.h>
+#include <language/data-io/file-handle.h>
 #include <libpspp/alloc.h>
+#include <libpspp/assertion.h>
 #include <libpspp/message.h>
-#include <language/data-io/file-handle.h>
-#include <data/file-name.h>
 #include <libpspp/str.h>
 
+#include "minmax.h"
+
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
 
@@ -36,7 +42,6 @@ struct dfm_writer
   {
     struct file_handle *fh;     /* File handle. */
     FILE *file;                 /* Associated file. */
-    char *bounce;               /* Bounce buffer for fixed-size fields. */
   };
 
 /* Opens a file handle for writing as a data file. */
@@ -55,7 +60,6 @@ dfm_open_writer (struct file_handle *fh)
   w = *aux = xmalloc (sizeof *w);
   w->fh = fh;
   w->file = fn_open (fh_get_file_name (w->fh), "wb");
-  w->bounce = NULL;
 
   if (w->file == NULL)
     {
@@ -79,9 +83,10 @@ dfm_write_error (const struct dfm_writer
   return ferror (writer->file);
 }
 
-/* Writes record REC having length LEN to the file corresponding to
-   HANDLE.  REC is not null-terminated.  Returns true on success,
-   false on failure. */
+/* Writes record REC (which need not be null-terminated) having
+   length LEN to the file corresponding to HANDLE.  Adds any
+   needed formatting, such as a trailing new-line.  Returns true
+   on success, false on failure. */
 bool
 dfm_put_record (struct dfm_writer *w, const char *rec, size_t len)
 {
@@ -89,20 +94,34 @@ dfm_put_record (struct dfm_writer *w, co
 
   if (dfm_write_error (w))
     return false;
-  
-  if (fh_get_mode (w->fh) == FH_MODE_BINARY
-      && len < fh_get_record_width (w->fh))
+
+  switch (fh_get_mode (w->fh)) 
     {
-      size_t rec_width = fh_get_record_width (w->fh);
-      if (w->bounce == NULL)
-        w->bounce = xmalloc (rec_width);
-      memcpy (w->bounce, rec, len);
-      memset (&w->bounce[len], 0, rec_width - len);
-      rec = w->bounce;
-      len = rec_width;
+    case FH_MODE_TEXT:
+      fwrite (rec, len, 1, w->file);
+      putc ('\n', w->file);
+      break;
+
+    case FH_MODE_BINARY:
+      {
+        size_t record_width = fh_get_record_width (w->fh);
+        size_t write_bytes = MIN (len, record_width);
+        size_t pad_bytes = record_width - write_bytes;
+        fwrite (rec, write_bytes, 1, w->file);
+        while (pad_bytes > 0) 
+          {
+            static const char spaces[32] = "                                ";
+            size_t chunk = MIN (pad_bytes, sizeof spaces);
+            fwrite (spaces, chunk, 1, w->file);
+            pad_bytes -= chunk;
+          }
+      }
+      break;
+
+    default:
+      NOT_REACHED ();
     }
 
-  fwrite (rec, len, 1, w->file);
   return !dfm_write_error (w);
 }
 
@@ -130,7 +149,6 @@ dfm_close_writer (struct dfm_writer *w)
       if (!ok)
         msg (ME, _("I/O error occurred writing data file \"%s\"."), file_name);
     }
-  free (w->bounce);
   free (w);
   free (file_name);
 
Index: src/language/data-io/print.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/print.c,v
retrieving revision 1.16
diff -u -p -r1.16 print.c
--- src/language/data-io/print.c	26 Oct 2006 06:16:36 -0000	1.16
+++ src/language/data-io/print.c	28 Oct 2006 19:18:52 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -22,6 +22,7 @@
 #include <stdlib.h>
 
 #include <data/case.h>
+#include <data/format.h>
 #include <data/procedure.h>
 #include <data/transformations.h>
 #include <data/variable.h>
@@ -65,6 +66,7 @@ struct prt_out_spec
     struct variable *var;	/* Associated variable. */
     struct fmt_spec format;	/* Output spec. */
     bool add_space;             /* Add trailing space? */
+    bool sysmis_as_spaces;      /* Output SYSMIS as spaces? */
 
     /* PRT_LITERAL only. */
     struct string string;       /* String to output. */
@@ -81,7 +83,7 @@ struct print_trns
   {
     struct pool *pool;          /* Stores related data. */
     bool eject;                 /* Eject page before printing? */
-    bool omit_new_lines;        /* Omit new-line characters? */
+    bool include_prefix;        /* Prefix lines with space? */
     struct dfm_writer *writer;	/* Output file, NULL=listing file. */
     struct ll_list specs;       /* List of struct prt_out_specs. */
     size_t record_cnt;          /* Number of records to write. */
@@ -147,7 +149,7 @@ internal_cmd_print (struct dataset *ds, 
   tmp_pool = pool_create_subpool (trns->pool);
 
   /* Parse the command options. */
-  while (token != '/')
+  while (token != '/' && token != '.')
     {
       if (lex_match_id ("OUTFILE"))
 	{
@@ -178,6 +180,10 @@ internal_cmd_print (struct dataset *ds, 
 	}
     }
 
+  /* When PRINT or PRINT EJECT writes to an external file, we
+     prefix each line with a space for compatibility. */
+  trns->include_prefix = which_formats == PRINT && fh != NULL;
+
   /* Parse variables and strings. */
   if (!parse_specs (tmp_pool, trns, dataset_dict (ds), which_formats))
     goto error;
@@ -190,9 +196,6 @@ internal_cmd_print (struct dataset *ds, 
       trns->writer = dfm_open_writer (fh);
       if (trns->writer == NULL)
         goto error;
-
-      trns->omit_new_lines = (which_formats == WRITE
-                              && fh_get_mode (fh) == FH_MODE_BINARY);
     }
 
   /* Output the variable table if requested. */
@@ -230,6 +233,12 @@ parse_specs (struct pool *tmp_pool, stru
   int record = 0;
   int column = 1;
 
+  if (token == '.') 
+    {
+      trns->record_cnt = 1;
+      return true;
+    }
+
   while (token != '.')
     {
       bool ok;
@@ -325,7 +334,7 @@ parse_variable_argument (const struct di
           struct variable *v = vars[i];
           formats[i] = which_formats == PRINT ? v->print : v->write; 
         }
-      add_space = true;
+      add_space = which_formats == PRINT;
     }
 
   var_idx = 0;
@@ -346,6 +355,15 @@ parse_variable_argument (const struct di
         spec->var = var;
         spec->format = *f;
         spec->add_space = add_space;
+
+        /* This is a completely bizarre twist for compatibility:
+           WRITE outputs the system-missing value as a field
+           filled with spaces, instead of using the normal format
+           that usually contains a period. */ 
+        spec->sysmis_as_spaces = (which_formats == WRITE
+                                  && var->type == NUMERIC
+                                  && !fmt_is_binary (spec->format.type));
+
         ll_push_tail (&trns->specs, &spec->ll);
 
         *column += f->w + add_space;
@@ -415,62 +433,83 @@ dump_table (struct print_trns *trns, con
 
 /* Transformation. */
 
-static void flush_records (struct print_trns *,
-                           int target_record, int *record);
+static void flush_records (struct print_trns *, int target_record,
+                           bool *eject, int *record);
 
 /* Performs the transformation inside print_trns T on case C. */
 static int
 print_trns_proc (void *trns_, struct ccase *c, casenumber case_num UNUSED)
 {
   struct print_trns *trns = trns_;
+  bool eject = trns->eject;
+  int record = 1;
   struct prt_out_spec *spec;
-  int record;
-
-  if (trns->eject)
-    som_eject_page ();
 
-  record = 1;
   ds_clear (&trns->line);
+  ds_put_char (&trns->line, ' ');
   ll_for_each (spec, struct prt_out_spec, ll, &trns->specs) 
     {
-      flush_records (trns, spec->record, &record);
+      flush_records (trns, spec->record, &eject, &record);
  
-      ds_set_length (&trns->line, spec->first_column - 1, ' ');
+      ds_set_length (&trns->line, spec->first_column, ' ');
       if (spec->type == PRT_VAR)
         {
-          data_out (ds_put_uninit (&trns->line, spec->format.w),
-                    &spec->format, case_data (c, spec->var->fv));
+          const union value *input = case_data (c, spec->var->fv);
+          char *output = ds_put_uninit (&trns->line, spec->format.w);
+          if (!spec->sysmis_as_spaces || input->f != SYSMIS)
+            data_out (output, &spec->format, input);
+          else
+            memset (output, ' ', spec->format.w);
           if (spec->add_space)
             ds_put_char (&trns->line, ' ');
         }
       else 
         ds_put_substring (&trns->line, ds_ss (&spec->string));
     }
-  flush_records (trns, trns->record_cnt + 1, &record);
+  flush_records (trns, trns->record_cnt + 1, &eject, &record);
   
   if (trns->writer != NULL && dfm_write_error (trns->writer))
     return TRNS_ERROR;
   return TRNS_CONTINUE;
 }
 
+/* Advance from *RECORD to TARGET_RECORD, outputting records
+   along the way.  If *EJECT is true, then the first record
+   output is preceded by ejecting the page (and *EJECT is set
+   false). */
 static void
-flush_records (struct print_trns *trns, int target_record, int *record)
+flush_records (struct print_trns *trns, int target_record,
+               bool *eject, int *record)
 {
-  while (target_record > *record) 
+  for (; target_record > *record; (*record)++) 
     {
+      char *line = ds_cstr (&trns->line);
+      size_t length = ds_length (&trns->line);
+      char leader = ' ';
+      
+      if (*eject) 
+        {
+          *eject = false;
+          if (trns->writer == NULL)
+            som_eject_page ();
+          else
+            leader = '1';
+        }
+      line[0] = leader;
+      
       if (trns->writer == NULL)
-        tab_output_text (TAB_FIX | TAT_NOWRAP, ds_cstr (&trns->line));
+        tab_output_text (TAB_FIX | TAT_NOWRAP, &line[1]);
       else
         {
-          if (!trns->omit_new_lines)
-            ds_put_char (&trns->line, '\n');
-
-          dfm_put_record (trns->writer,
-                          ds_data (&trns->line), ds_length (&trns->line));
+          if (!trns->include_prefix) 
+            {
+              line++;
+              length--; 
+            }
+          dfm_put_record (trns->writer, line, length);
         }
-      ds_clear (&trns->line);
-
-      (*record)++;
+      
+      ds_truncate (&trns->line, 1);
     }
 }
 
Index: tests/command/print.sh
===================================================================
RCS file: /cvsroot/pspp/pspp/tests/command/print.sh,v
retrieving revision 1.25
diff -u -p -r1.25 print.sh
--- tests/command/print.sh	18 Jul 2006 04:57:02 -0000	1.25
+++ tests/command/print.sh	28 Oct 2006 19:18:53 -0000
@@ -1,6 +1,21 @@
 #!/bin/sh
 
-# This program tests the PRINT transformation
+# This program tests unusual aspects of the PRINT and WRITE
+# transformations:
+#
+#   - PRINT puts spaces between variables, unless a format 
+#     is specified explicitly.
+#
+#   - WRITE doesn't put space between variables.
+#
+#   - PRINT to an external file prefixes each line with a space.
+#
+#   - PRINT EJECT to an external file indicates a formfeed by a "1"
+#     in the first column.
+#
+#   - WRITE writes out spaces for system-missing values, not a period.
+#
+#   - When no output is specified, an empty record is output.
 
 TEMPDIR=/tmp/pspp-tst-$$
 TESTFILE=$TEMPDIR/`basename $0`.sps
@@ -54,127 +69,118 @@ mkdir -p $TEMPDIR
 
 cd $TEMPDIR
 
-# Copy this file --- it's shared with another test
-activity="create data"
-cp $top_srcdir/tests/data-list.data $TEMPDIR
-if [ $? -ne 0 ] ; then no_result ; fi
-
-
 activity="create program"
 cat > $TEMPDIR/print.stat << foobar
-title 'Test PRINT transformation'.
-
-data list free table file='$TEMPDIR/data-list.data'/A B C D.
-print outfile="foo" table/A(f8.2) '/' B(e8.2) '/' C(n10) '/'.
-print space a.
-print outfile="foo" /a b c d.
-list.
-
-data list list table file='$TEMPDIR/data-list.data'/A B C D.
-print table/A B C D.
-list.
+data list notable /x y 1-2.
+begin data.
+12
+34
+ 6 
+7 
+90
+end data.
+
+print /x y.
+print eject /x y 1-2.
+print /x '-' y.
+print.
+
+print outfile='print.out' /x y.
+print eject outfile='print.out' /x y (f1,f1).
+print outfile='print.out' /x '-' y.
+print outfile='print.out'.
+
+write outfile='write.out' /x y.
+write outfile='write.out' /x y (2(f1)).
+write outfile='write.out' /x '-' y.
+write outfile='write.out'.
 
+execute.
 foobar
 if [ $? -ne 0 ] ; then no_result ; fi
 
 
 activity="run program"
 $SUPERVISOR $PSPP --testing-mode -o raw-ascii --testing-mode $TEMPDIR/print.stat > $TEMPDIR/errs
-# Note   vv   --- there are errors in input.  Therefore, the  command must FAIL
-if [ $? -eq 0 ] ; then fail ; fi
+if [ $? -ne 0 ] ; then fail ; fi
 
-activity="compare error messages"
-diff -w $TEMPDIR/errs - <<EOF
-$TEMPDIR/data-list.data:1: error: (columns 1-5, field type F8.0) Field does not form a valid floating-point constant.
-$TEMPDIR/data-list.data:1: warning: LIST: The expression on PRINT SPACE evaluated to the system-missing value.
-$TEMPDIR/data-list.data:2: error: (columns 1-8, field type F8.0) Field does not form a valid floating-point constant.
-$TEMPDIR/data-list.data:4: warning: LIST: The expression on PRINT SPACE evaluated to the system-missing value.
-$TEMPDIR/data-list.data:4: error: (columns 3-12, field type F8.0) Field does not form a valid floating-point constant.
-$TEMPDIR/data-list.data:6: warning: LIST: The expression on PRINT SPACE evaluated to the system-missing value.
-$TEMPDIR/data-list.data:1: error: (columns 1-5, field type F8.0) Field does not form a valid floating-point constant.
-$TEMPDIR/data-list.data:2: error: (columns 1-8, field type F8.0) Field does not form a valid floating-point constant.
-$TEMPDIR/data-list.data:2: warning: LIST: Missing value(s) for all variables from C onward.  These will be filled with the system-missing value or blanks, as appropriate.
-$TEMPDIR/data-list.data:3: warning: LIST: Missing value(s) for all variables from B onward.  These will be filled with the system-missing value or blanks, as appropriate.
-$TEMPDIR/data-list.data:4: error: (columns 3-12, field type F8.0) Field does not form a valid floating-point constant.
-$TEMPDIR/data-list.data:4: warning: LIST: Missing value(s) for all variables from C onward.  These will be filled with the system-missing value or blanks, as appropriate.
-$TEMPDIR/data-list.data:5: warning: LIST: Missing value(s) for all variables from C onward.  These will be filled with the system-missing value or blanks, as appropriate.
-$TEMPDIR/data-list.data:6: warning: LIST: Missing value(s) for all variables from B onward.  These will be filled with the system-missing value or blanks, as appropriate.
+activity="compare print.out"
+diff $TEMPDIR/print.out - <<EOF
+ 1 2 
+112
+ 1 -2 
+ 
+ 3 4 
+134
+ 3 -4 
+ 
+ . 6 
+1.6
+ . -6 
+ 
+ 7 . 
+17.
+ 7 -. 
+ 
+ 9 0 
+190
+ 9 -0 
+ 
 EOF
 if [ $? -ne 0 ] ; then fail ; fi
 
+activity="compare write.out"
+diff $TEMPDIR/write.out - <<EOF
+12
+12
+1-2
+
+34
+34
+3-4
+
+ 6
+ 6
+ -6
+
+7 
+7 
+7- 
+
+90
+90
+9-0
 
-activity="compare output"
-perl -pi -e 's/^\s*$//g' $TEMPDIR/pspp.list
-diff -b  $TEMPDIR/pspp.list - << EOF
-1.1 DATA LIST.  Reading free-form data from "$TEMPDIR/data-list.data".
-+--------+------+
-|Variable|Format|
-#========#======#
-|A       |F8.0  |
-|B       |F8.0  |
-|C       |F8.0  |
-|D       |F8.0  |
-+--------+------+
-2.1 PRINT.  Writing 1 record to "foo".
-+--------+------+-------+------+
-|Variable|Record|Columns|Format|
-#========#======#=======#======#
-|A       |     1|  1-  8|F8.2  |
-|"/"     |     1|  9-  9|      |
-|B       |     1| 10- 17|E8.2  |
-|"/"     |     1| 18- 18|      |
-|C       |     1| 19- 28|N10.0 |
-|"/"     |     1| 29- 29|      |
-+--------+------+-------+------+
-       A        B        C        D
--------- -------- -------- --------
-     .       2.00     3.00     4.00 
-     .       6.00     7.00     8.00 
-     .      10.00    11.00    12.00 
-3.1 DATA LIST.  Reading free-form data from "$TEMPDIR/data-list.data".
-+--------+------+
-|Variable|Format|
-#========#======#
-|A       |F8.0  |
-|B       |F8.0  |
-|C       |F8.0  |
-|D       |F8.0  |
-+--------+------+
-4.1 PRINT.  Writing 1 record.
-+--------+------+-------+------+
-|Variable|Record|Columns|Format|
-#========#======#=======#======#
-|A       |     1|  1-  8|F8.2  |
-|B       |     1| 10- 17|F8.2  |
-|C       |     1| 19- 26|F8.2  |
-|D       |     1| 28- 35|F8.2  |
-+--------+------+-------+------+
-     .       2.00     3.00     4.00 
-       A        B        C        D
--------- -------- -------- --------
-     .       2.00     3.00     4.00 
-     .       6.00      .        .   
-     .       6.00      .        .   
-    7.00      .        .        .   
-    7.00      .        .        .   
-    8.00      .        .        .   
-    8.00      .        .        .   
-   10.00    11.00      .        .   
-   10.00    11.00      .        .   
-   12.00      .        .        .   
-   12.00      .        .        .   
 EOF
 if [ $? -ne 0 ] ; then fail ; fi
 
+activity="compare output"
+diff $TEMPDIR/pspp.list - << EOF
+1 2 
+
+12
+1 -2 
+
+3 4 
+
+34
+3 -4 
+
+. 6 
+
+.6
+. -6 
+
+7 . 
+
+7.
+7 -. 
+
+9 0 
+
+90
+9 -0 
 
-activity="compare print out"
-diff $TEMPDIR/foo - << EOF
-     .  /2.00E+00/0000000003/
-     .       2.00     3.00     4.00 
-     .  /6.00E+00/0000000007/
-     .       6.00     7.00     8.00 
-     .  /1.00E+01/0000000011/
-     .      10.00    11.00    12.00 
 EOF
 if [ $? -ne 0 ] ; then fail ; fi
 
